MARTe2-core - User story #133

MARTe-EX-D-1.4.1: The framework shall offer portable memory management functions (malloc,
realloc, free, compare and move) to developers.

29.05.2015 14:19 - André Neto

Status: Closed Start date:
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 4.00 hours
Target version: 0.2 Spent time: 0.00 hour
Git branch (link): SVN commit
(link/?p=rev):
Git merge to develop
(link):
Description
See #152

Implement requirement MARTe-EX-D-1.4.1 based on the original MARTe implementation

Note: Given that the framework is expected to be deployed and portable to very embedded systems it was decided not to assume
that the stdlib malloc and free might be available everywhere.

Source code files modified

°

Source/Core/L0Portability/Memory.cpp

Source/Core/LOPortability/Memory.h
Source/Core/L0Portability/MemoryStatistics.h
Source/Core/L0Portability/OperatingSystem/Linux/GeneralDefinitionsOS.h
Source/Core/L0Portability/OperatingSystem/Linux/MemoryOS.h
Source/Core/L0Portability/OperatingSystem/Windows/GeneralDefinitionsOS.h
Source/Core/L0Portability/OperatingSystem/Windows/MemoryOS.h

Architecture & design review
Date of the review: 12/06/2015
Person who did the review: André Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is a support function and does
not require formal design in UML.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review
Date of the review: 01/07/2015

Person who did the review: Ivan Herrero

Result of review: PASS

List of non-conformities: N/A

Associated revisions

Revision c42051b9 - 18.06.2015 14:39 - Giuseppe Ferro

Added Memory implementation.
https://vcis-redmine.f4e.europa.eu/issues/152

#133

Revision 131a478e - 22.06.2015 14:03 - Giuseppe Ferro

Added internal semaphore to the memory database.
#133

Revision 229aac3f - 23.06.2015 11:55 - Giuseppe Ferro

Fixed warnings.
#133

Revision 9fa2634d - 23.06.2015 13:13 - Giuseppe Ferro

Fixed issues accordingly with revision.
#133

Revision 29d232c0 - 01.07.2015 08:51 - Giuseppe Ferro

Fixed MemoryStatistics support.
#133

Revision 3a0339b1 - 01.07.2015 09:09 - Giuseppe Ferro

Added MemorylIntegration tests
#133

Revision 8c62e924 - 02.07.2015 12:20 - Giuseppe Ferro

Add null check in MemoryStringDup
#133

Revision 39c¢f5317 - 28.07.2015 12:00 - Giuseppe Ferro
Minor changes in Memory tests.

#133

History

#1 - 03.06.2015 11:23 - Riccardo Vitelli

- Target version changed from Backlog to 0.1
- Start date deleted (29.05.2015)

- Estimated time set to 4.00 h

#2 - 12.06.2015 10:31 - Riccardo Vitelli

- Status changed from New to Arch: Rev

#3 - 12.06.2015 11:15 - Riccardo Vitelli

- Assignee set to André Neto

#4 - 12.06.2015 18:29 - André Neto

- Description updated

#5 - 18.06.2015 12:42 - Giuseppe Ferro
- Status changed from Arch: Rev to Code: Impl

#6 - 18.06.2015 12:42 - Giuseppe Ferro

- Assignee changed from André Neto to Giuseppe Ferro

#7 - 18.06.2015 16:32 - Giuseppe Ferro
- Status changed from Code: Impl to Code: Rev

#8 - 18.06.2015 16:32 - Giuseppe Ferro
- Status changed from Code: Rev to Code: Impl

#9 - 22.06.2015 17:29 - Riccardo Vitelli

05.04.2025

2/4



- Status changed from Code: Impl to Code: Rev

#10 - 22.06.2015 17:30 - Riccardo Vitelli

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#11 - 22.06.2015 19:05 - Ivan Herrero
- Description updated

- Assignee deleted (Ilvan Herrero)

Code and documentation review made. Code and documentation corrections pending.

#12 - 23.06.2015 16:09 - Ivan Herrero
- Description updated

Added new review to Memory.cpp (rule violations detected).

#13 - 23.06.2015 18:02 - André Neto
- Status changed from Code: Rev to Code: Impl

#14 - 23.06.2015 18:03 - André Neto

- Assignee set to Giuseppe Ferro

#15 - 25.06.2015 17:18 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#16 - 25.06.2015 17:20 - Riccardo Vitelli
- Assignee deleted (Giuseppe Ferro)

#17 - 25.06.2015 19:15 - Ivan Herrero
- Description updated

Source/Core/LOPortability/Memory.cpp correction not finished, caused by MISRA violations (discuss with AN and RV if we delay its correction after
the first FlexeLint execution).

#18 - 25.06.2015 19:15 - Ivan Herrero
- Status changed from Code: Rev to Code: Impl

#19 - 26.06.2015 11:44 - Giuseppe Ferro

- Assignee set to Giuseppe Ferro

#20 - 29.06.2015 09:52 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#21 - 29.06.2015 09:53 - Riccardo Vitelli
- Assignee deleted (Giuseppe Ferro)

#22 - 01.07.2015 11:07 - Ivan Herrero
- Description updated

- Assignee set to Ivan Herrero

Code and documentation review made on revision 8e15315 [PASS].

Violation of rule 5-2-4 on lines 82, 122, 133, 166, 229 of Source/Core/LOPortability/Memory.cpp ignored (delayed until full Flexelint analysis).

#23 - 01.07.2015 13:07 - Riccardo Vitelli
- Status changed from Code: Rev to Unit: Impl
#24 - 01.07.2015 13:07 - Riccardo Vitelli

- Assignee deleted (lvan Herrero)

#25 - 02.07.2015 18:06 - Riccardo Vitelli

- Target version changed from 0.1 to 0.2

#26 - 28.07.2015 11:43 - Giuseppe Ferro

- Assignee set to Giuseppe Ferro

#27 - 28.07.2015 12:01 - Giuseppe Ferro
- Assignee deleted (Giuseppe Ferro)

Unit Tests implementation done. #39cf53f

#28 - 28.07.2015 12:01 - Giuseppe Ferro
- Status changed from Unit: Impl to Unit: Rev

#29 - 29.07.2015 15:15 - Riccardo Vitelli

- Description updated

#30 - 29.07.2015 15:15 - Riccardo Vitelli
- Status changed from Unit: Rev to Closed
